<template>
    <v-dialog v-model="showDialog" max-width="600px">
        <v-card tile>
            <v-toolbar flat dark color="black">
                <v-toolbar-title class="title">{{ auxIngredient.name }}</v-toolbar-title>
                <v-spacer></v-spacer>
                <v-toolbar-items>
                    <v-btn icon dark @click="closeWindow">
                        <v-icon>mdi-close</v-icon>
                    </v-btn>
                </v-toolbar-items>
            </v-toolbar>
            <v-container class="px-7">
                <v-form v-model="valid" lazy-validation ref="form">
                    <v-row>
                        <v-col>
                            <v-text-field
                                v-model="auxIngredient.name"
                                label="Nombre"
                                hide-details
                                :rules="[v => !!v || 'Campo requerido']"
                                required
                            ></v-text-field>
                        </v-col>
                    </v-row>
                    <v-row>
                        <v-col>
                            <span class="label">Configuraciones por idioma</span>
                            <v-tabs background-color="transparent" grow v-model="tab">
                                <v-tabs-slider></v-tabs-slider>
                                <v-tab
                                    v-for="(lang, key) in langsMenu"
                                    :key="key"
                                    style="font-weight:bold; font-size: small; border-radius: 0"
                                >
                                    {{ lang.language }}
                                </v-tab>
                            </v-tabs>
                            <v-tabs-items v-model="tab">
                                <v-tab-item v-for="(lang, key) in langsMenu" :key="key" eager>
                                    <v-card flat style="overflow: hidden;">
                                        <v-text-field
                                            label="Nombre"
                                            :value="
                                                langsIngredientFromComponent.get(lang.id)
                                                    ? langsIngredientFromComponent.get(lang.id).text
                                                    : undefined
                                            "
                                            @input="changeLangText($event, lang.id, lang.language)"
                                            :rules="[v => !!v || 'Campo requerido']"
                                            row-height="20"
                                            rows="2"
                                            auto-grow
                                        ></v-text-field>
                                    </v-card>
                                </v-tab-item>
                            </v-tabs-items>
                        </v-col>
                    </v-row>
                </v-form>
                <v-row>
                    <v-spacer></v-spacer>
                    <v-btn class="add" @click="saveIngredient($event, auxIngredient)" depressed :disabled="!valid"
                        >Guardar</v-btn
                    >
                </v-row>
            </v-container>
        </v-card>
    </v-dialog>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
import { Ingredient as IngredientModel } from '@/model/menu/Ingredient';
import { LangMenu } from '@/model/menu/LangMenu';
import { LangText } from '@/model/LangText';
import { db } from '@/config/firebase';
import { INGREDIENT_NAMES, INGREDIENTS, MENUS } from '@/config/collectionsName';
import { serializeLangText } from '@/config/serializables';
import LangList from '@/components/menu/LangList.vue';
import { isAlpha } from '@/StringUtils';

@Component({ components: { LangList } })
export default class Ingredient extends Vue {
    @Prop({ default: new IngredientModel('', 0, '', '', false) })
    ingredient!: IngredientModel;
    @Prop({ default: () => [] })
    langsMenu!: LangMenu[];
    @Prop({ default: false })
    showDialog!: boolean;
    @Prop({ required: true })
    menuId!: string;
    @Prop({ required: true })
    dishId!: string;

    tab = null;
    valid = true;
    auxIngredient: IngredientModel = new IngredientModel('', 0, '', '', false);
    langsIngredientFromFire: LangText[] = [];
    langsIngredientFromComponent: Map<string, LangText> = new Map();
    nameRules = [
        (v: string | undefined) => !!v || 'Nombre de ingrediente es requerido',
        (v: string | undefined) => (v && v.length > 1) || 'Nombre de ingrediente debe tener al menos 2 caracteres',
        (v: string) => isAlpha(v) || 'Nombre de ingrediente no debe contener caracteres especiales'
    ];

    changeLangText(input: string, langId: string, lang: string) {
        this.langsIngredientFromComponent.set(langId, new LangText(langId, lang, input));
    }

    saveIngredient(event: Event, ingredient: IngredientModel) {
        const isValid = (this.$refs.form as Vue & { validate: () => boolean }).validate();
        if (isValid && ingredient.id) {
            const langIngredientToFire = Array.from(this.langsIngredientFromComponent.values()).filter(
                langCat => langCat.text
            );
            this.$emit('saveIngredient', ingredient, langIngredientToFire);
        }
    }

    closeWindow() {
        this.$emit('setIngredientModal', false);
        this.auxIngredient = Object.assign(this.auxIngredient, this.ingredient);
    }

    @Watch('ingredient')
    async onCategoryChange(newIngredient: IngredientModel | null) {
        if (newIngredient && newIngredient.id) {
            await this.$bind(
                'langsIngredientFromFire',
                db
                    .collection(MENUS)
                    .doc(this.menuId)
                    .collection(INGREDIENTS)
                    .doc(newIngredient.id)
                    .collection(INGREDIENT_NAMES),
                {
                    serialize: serializeLangText
                }
            );
        }

        if (!newIngredient?.id) {
            this.langsIngredientFromFire = [];
        }
        this.langsIngredientFromComponent = new Map();
        this.langsIngredientFromFire.forEach(lang => this.langsIngredientFromComponent.set(lang.id, lang));
        this.auxIngredient = Object.assign(this.auxIngredient, this.ingredient);
    }
}
</script>

<style type="text/css"></style>
